﻿package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.TextField;
	
	public class Main extends Sprite
	{
		private const GRAPHWIDTH:Number = 500;
		private const GRAPHHEIGHT:Number = 400;
		
		
		private var xml:XML;
		
		private var graphPaper:Sprite;
		private var graph:Sprite;
		
		
		public function Main():void
		{
			var urlRequest:URLRequest = new URLRequest("data.xml");
			var xmlLoader:URLLoader = new URLLoader(urlRequest);
			
			xmlLoader.addEventListener(Event.COMPLETE, displayGraph);
		}
		
		private function displayGraph(e:Event):void {
			xml = new XML(e.target.data);

			graphPaper = new Sprite();
			
			drawGraphPaper();
			drawGraph();
			
			addChild(graphPaper);
		}
		
		private function drawGraph():void
		{
			graph = new Sprite();
			this.addChild(graph);
			
			var numPoints:int = xml.values.children().length();
			
			graph.graphics.lineStyle(1, Number(xml.values.@lineColour),1);
			
			var counter:int = 0;
			
			for each(var item:XML in xml.values.value) {
				if (counter == 0)
				{
					graph.graphics.moveTo(Number(item.@key), GRAPHHEIGHT-Number(item.@value) );
				}else
				{
					graph.graphics.lineTo(Number(item.@key), GRAPHHEIGHT-Number(item.@value) );
				}
				//put a text box showing the value
				var graphLabel:TextField = new TextField();
				graphLabel.text = item.@value;
				graphLabel.x = Number(item.@key)-graphLabel.textWidth/2;
				graphLabel.y = GRAPHHEIGHT - Number(item.@value) - graphLabel.textHeight / 2;
				graphLabel.backgroundColor = 0xFFFFAA;
				graphLabel.background = true;
				graphLabel.width = graphLabel.textWidth+5;
				graphLabel.height = graphLabel.textHeight+5;
				graph.addChild(graphLabel);
				
				counter++;
            }
		}
		
		private function drawGraphPaper():void {
			
			//graph paper..
			graphPaper.graphics.lineStyle(1, Number(xml.settings.graphLineColour.@value), Number(xml.settings.graphLineColour.@alpha)/100);
	
			var numLines:Number = GRAPHHEIGHT/(Number(xml.settings.split.@value)*Number(xml.settings.pixelscale.@value))
			graphPaper.graphics.moveTo(0, 0);			
			
			for (var i:Number=0; i <numLines ; i++) {
				graphPaper.graphics.moveTo(0, GRAPHHEIGHT - (i * Number(xml.settings.split.@value) * Number(xml.settings.pixelscale.@value)));
				graphPaper.graphics.lineTo(GRAPHWIDTH, GRAPHHEIGHT-(i*Number(xml.settings.split.@value)*Number(xml.settings.pixelscale.@value)));
			}
		
		}
		
		
	}
}